

// Test Cholesky module

#include <iostream.h>

#include "tnt.h"
#include "vec.h"
#include "cmat.h"
//#include "cholesky.h"
#include "btl/CholeskyInverse.h"
#include "trislv.h"
#include "transv.h"         /* tranpose views */

main()
{
    C_matrix<double> A;

    cin >> A;

    Subscript N = A.num_rows();
    assert(N == A.num_cols());

    Vector<double> b(N, 1.0);   // b= [1,1,1,...]

    //BTL Copy original into result matrix
    //
    C_matrix<double> L = A;

    cerr << "A: " << A << endl;
   
    BTL_CholeskyInverse< C_matrix<double> >::Invert(L);    
    BTL_CholeskyInverse< C_matrix<double> >::Invert(L);    
    
    C_matrix<double> residual = A-L;
    
    cerr << "Residual: A - inverse(inverse(A)) " << residual;
}
